<template>
  <div
    v-click-outside="onOutsideClick"
    class="ob-inline-select"
    :class="{ readonly: readonly, disabled: disabled }"
  >
    <div
      ref="reference"
      :class="['ob-inline-select__label', isValid ? '' : 'ob-inline-select__label--error']"
      :data-qa="dataQa"
      @click="toggle"
    >
      <i
        v-if="selected && selected.icon && isValid"
        :class="['icon', selected.icon]"
      />
      <ob-tooltip
        v-if="!isValid"
        :content="errorTooltip"
        position="top"
        type="error"
      >
        <i class="icon alert" />
      </ob-tooltip>
      <div
        class="ob-inline-select__label-text"
        :style="labelStyle"
      >
        {{ selected ? valueLabelExpr ? selected[valueLabelExpr] : selected[displayExpr] : label }}<span
          v-if="!selected && isRequired"
          class="required"
        >*</span>
      </div>
      <i
        v-if="!isOpen"
        class="icon chevron-down"
      />
      <i
        v-if="isOpen"
        class="icon chevron-up"
      />
    </div>
    <div class="select-dropdown"
      ref="popper"
      v-if="isOpen"
      data-attr="ob-inline-select"
      position="bottom-start"
      :data-qa="dataQa"
      :width-inherit="inheritWidth"
      :bound-padding="5"
      :popper-class="popperClass"
    >
      <div
        v-if="isShowSearch"
        class="search"
      >
        <input
          v-model.trim="searchQuery"
          v-debounce:500ms.lock="onSearch"
          type="text"
          @keydown.esc="onEscape"
        >
        <i
          class="icon search ob-selector__list-filter-icon"
        />
      </div>
      <div
        v-if="!isGrouped"
        class="ob-inline-select__list"
      >
        <slot :items="localItems">
          <div
            v-for="(item, index) in localItems"
            :key="index"
            class="ob-inline-select__list-item"
            :data-qa="dataQa"
            @click="select(item)"
          >
            {{ item[displayExpr] }}
          </div>
        </slot>
      </div>
      <div
        v-if="isGrouped"
        class="ob-inline-select__list"
      >
        <slot :items="localItems">
          <div
            v-for="(title, index) in localItems"
            :key="index"
            class="ob-inline-select__group"
          >
            <div
              class="ob-inline-select__group-title"
              :data-qa="dataQa"
            >
              {{ title[groupDisplayExpr] }}
            </div>
            <div
              v-for="item in title[groupChildExpr]"
              :key="item[valueExpr]"
              class="ob-inline-select__list-item"
              @click="select(item)"
            >
              {{ item[displayExpr] }}
            </div>
          </div>
        </slot>
      </div>
    </div>
  </div>
</template>

<script>
import Vue from 'vue'
import vueDebounce from 'vue-debounce'
import ClickOutside from 'vue-click-outside'
import ObTooltip from 'common-components/src/obComponents/obTooltip'

Vue.use(vueDebounce)

export default {
  name: "draftInlineSelect",
  components: {
    ObTooltip
  },
  directives: {
    ClickOutside
  },
  provide () {
    return {
      select: this
    }
  },
  props: {
    value: {
      type: String,
      default: ''
    },
    label: {
      type: String,
      default: 'Label'
    },
    items: {
      type: Array,
      default: () => []
    },
    valueExpr: {
      type: String,
      default: 'uuid'
    },
    displayExpr: {
      type: String,
      default: 'title'
    },
    readonly: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    },
    isRequired: {
      type: Boolean,
      default: false
    },
    inheritWidth: {
      type: Boolean,
      default: true
    },
    isValid: {
      type: Boolean,
      default: true
    },
    errorTooltip: {
      type: String
    },
    maxWidth: {
      type: [Number, String]
    },
    isGrouped: {
      type: Boolean,
      default: false
    },
    groupDisplayExpr: {
      type: String,
      default: 'groupTitle'
    },
    groupChildExpr: {
      type: String,
      default: 'items'
    },
    valueLabelExpr: {
      type: String
    },
    dataQa: {
      type: String
    },
    popperClass: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      localItems: [],
      isOpen: false,
      searchQuery: '',
      isShowSearch: false
    }
  },
  computed: {
    selected () {
      if (this.isGrouped) {
        const res = this.items.reduce((acc, item) => {
          const data = item[this.groupChildExpr].find(child => child[this.valueExpr] === this.value)
          if (data) {
            acc = data
          }
          return acc
        }, {})
        return this.value ? res : ''
      }
      return this.value
        ? this.items.find(i => i[this.valueExpr] === this.value) : ''
    },

    labelStyle () {
      return this.maxWidth ? { maxWidth: `${this.maxWidth}px`, overflow: 'hidden', textOverflow: 'ellipsis' } : ''
    }
  },
  watch: {
    items: {
      handler (newVal) {
        let groupedItems = 0
        if (this.isGrouped) {
          groupedItems = newVal.reduce((acc, item) => {
            return acc + item[this.groupChildExpr].length
          }, 0)
        }
        this.isShowSearch = newVal.length > 10 || groupedItems > 10
        this.localItems = newVal
      },
      immediate: true
    }
  },
  methods: {
    onSearch () {
      if (this.searchQuery === '') this.localItems = this.items
      if (!this.isGrouped) {
        this.localItems = this.items.filter((item) =>
          item[this.displayExpr].toLowerCase().includes(this.searchQuery.toLowerCase())
        )
      } else {
        const re = new RegExp(this.searchQuery, 'i')
        this.localItems = this.items.map(item => {
          const res = item[this.groupChildExpr].filter(child => {
            return child[this.displayExpr].search(re) !== -1
          })
          if (res.length) {
            return {
              [this.groupDisplayExpr]: item[this.groupDisplayExpr],
              [this.groupChildExpr]: res
            }
          } else {
            return {}
          }
        })
      }
      this.$emit('search', this.searchQuery)
    },
    toggle () {
      if (this.readonly || this.disabled) return
      this.isOpen = !this.isOpen
      if (this.searchQuery.length) {
        this.searchQuery = ''
        this.onSearch()
        this.$emit('search', this.searchQuery)
      }
    },
    onOutsideClick ($event) {
      let target = $event.target
      let popper = this.$refs.popper
      if (popper) {
        if (target === popper || popper.contains(target)) {
          return false
        } else {
          this.isOpen = false
          if (this.searchQuery.length) {
            this.searchQuery = ''
            this.onSearch()
            this.$emit('search', this.searchQuery)
          }
        }
      }
    },
    onEscape () {
      this.isOpen = false
      if (this.searchQuery.length) {
        this.searchQuery = ''
        this.$emit('search', this.searchQuery)
      }
    },
    select (item) {
      this.isOpen = false
      this.searchQuery = ''
      this.$emit('input', item[this.valueExpr])
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-inline-select {
  display: inline-flex;
  position: relative;

  &__label {
    display: inline-flex;
    align-items: center;
    color: $color-blue-navy-blue;
    cursor: pointer;

    .readonly & {
      color: $color-text-base;
      cursor: default;
    }
    .disabled & {
      color: $color-grey-span;
      cursor: default;
    }
    .icon {
      margin-right: 5px;
      .ob-input-container & {
        margin-right: 0;
        position: relative;
        left: 2px;
      }
    }
  }
  &__list {
    display: flex;
    flex-direction: column;
    max-height: 320px;
    overflow: auto;
    &-item {
      padding: 8px 16px;
      font-size: 14px;
      line-height: 16px;
      letter-spacing: 0.2px;
      color: $color-text-base;
      cursor: pointer;
      &:first-child {
        margin-top: 8px;
      }
      &:last-child {
        margin-bottom: 8px;
      }
      &:hover {
        background-color: $blue-blue-hoarfrost;
      }
    }
  }
}
.ob-inline-select__label {
  display: inline-flex;
  justify-content: space-between;

  &--error,
  .alert {
    color: $color-error;
  }
}

.ob-inline-select__label-text {
  white-space: nowrap;

  & + .icon {
    margin-right: 0;
    margin-left: 5px;
  }
}

.search {
  padding: 16px 28px 0;

  input {
    background: $background-white;
    border: 1px solid $color-grey-border;
    box-sizing: border-box;
    border-radius: 3px;
    padding: 16px 0 16px 12px;
    width: 100%;
  }
}

.required {
  margin-left: 0.2em;
  color: $color-error;
}

.ob-inline-select__group {
  &:first-child {
    margin-top: 15px;
  }

  .ob-inline-select__list-item {
    font-size: 16px;
    padding-left: 30px;
  }
}

.ob-inline-select__group-title {
  display: flex;
  align-items: center;
  padding: 11px 20px 4px 20px;
  font-size: 18px;
  font-weight: 700;

  i {
    margin-right: 5px;
    font-size: 20px;
    color: $color-blue-smalt;
  }
}

.select-dropdown {
  position: absolute;
  top: calc(100% + 3px);
  left: 0;
  min-width: 150px;
  padding: 0;
  background: #FFFFFF;
  border-radius: 2px;
  font-family: Roboto, sans-serif;
  font-style: normal;
  font-weight: normal;
  font-size: 12px;
  line-height: 16px;
  letter-spacing: 0.2px;
  color: #191E32;
  box-shadow: 0 4px 8px rgba($color-blue-navy-blue, 0.25);
}
</style>
